import java.awt.*;

public class DrawingAircraftCarrier extends  DrawingWarship{

    public DrawingAircraftCarrier(int speed, float weight, Color bodyColor, Color dopColor, boolean bodyKit, boolean cabin, boolean superEngine)
    {
        super(speed, weight, bodyColor, 114, 40);
        Warship = new EntityAircraftCarrier(speed, weight, bodyColor, dopColor, bodyKit, cabin, superEngine);
    }

    @Override
    public void DrawTransport(Graphics gr){
        if(!(Warship instanceof EntityAircraftCarrier))
        {
            return;
        }
        Graphics2D g2 = (Graphics2D) gr;
        EntityAircraftCarrier aircraftCarrier = (EntityAircraftCarrier) Warship;

        if (aircraftCarrier.GetBodyKit())
        {
            //боковая площадка
            int[] pointXArea = {_startPosX + 94, _startPosX + 74, _startPosX + 24, _startPosX + 4};
            int[] pointYArea = {_startPosY + 40, _startPosY + 60, _startPosY + 60, _startPosY + 40};
            g2.setColor(Warship.GetBodyColor());
            g2.fillPolygon(pointXArea, pointYArea, 4);
            g2.setColor(Color.BLACK);
            g2.drawPolygon(pointXArea, pointYArea, 4);

            //полоса
            int[] pointXLine = {_startPosX + 4, _startPosX + 15, _startPosX + 74, _startPosX + 59};
            int[] pointYLine = {_startPosY, _startPosY, _startPosY + 60, _startPosY + 60};
            g2.setColor(Color.GRAY);
            g2.fillPolygon(pointXLine, pointYLine, 4);
            g2.setColor(Color.BLACK);
            g2.drawPolygon(pointXLine, pointYLine, 4);
        }

        if (aircraftCarrier.GetSuperEngine())
        {
            g2.setColor(Color.RED);
            g2.fillOval(_startPosX, _startPosY, 10, 10);
            g2.setColor(Color.BLACK);
            g2.drawOval(_startPosX, _startPosY, 10, 10);

            g2.setColor(Color.RED);
            g2.fillOval(_startPosX, _startPosY + 10, 10, 10);
            g2.setColor(Color.BLACK);
            g2.drawOval(_startPosX, _startPosY + 10, 10, 10);

            g2.setColor(Color.RED);
            g2.fillOval(_startPosX, _startPosY + 18, 10, 10);
            g2.setColor(Color.BLACK);
            g2.drawOval(_startPosX, _startPosY + 18, 10, 10);

            g2.setColor(Color.RED);
            g2.fillOval(_startPosX, _startPosY + 30, 10, 10);
            g2.setColor(Color.BLACK);
            g2.drawOval(_startPosX, _startPosY + 30, 10, 10);
        }

        super.DrawTransport(g2);

        if (aircraftCarrier.GetCabin())
        {
            g2.setColor(Color.GRAY);
            g2.fillOval(_startPosX + 80, _startPosY + 13, 10, 14);
            g2.setColor(Color.BLACK);
            g2.drawOval(_startPosX + 80, _startPosY + 13, 10, 14);

            g2.setColor(Color.GRAY);
            g2.fillOval(_startPosX + 90, _startPosY + 13, 10, 14);
            g2.setColor(Color.BLACK);
            g2.drawOval(_startPosX + 90, _startPosY + 13, 10, 14);

            g2.setColor(Color.GRAY);
            g2.fillRect(_startPosX + 85, _startPosY + 13, 10, 14);
            g2.setColor(Color.BLACK);
            g2.drawRect(_startPosX + 85, _startPosY + 13, 10, 14);
        }
    }
}
