import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.util.Random;

public class DrawingMap extends JPanel{
    private final FormMap Map;
    private AbstractMap _abstractMap;
    BufferedImage bufferedImage;
    public DrawingMap(FormMap map){
        Map = map;
        _abstractMap = new SimpleMap();
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.drawImage(bufferedImage,0,0,null);
    }

    private void SetData(DrawingWarship warship) {
        Random rnd = new Random();
        warship.SetPosition(rnd.nextInt(10, 100), rnd.nextInt(10, 100), getWidth(),getHeight());
        Map.toolBarLabelSpeed.setText("Color: " + warship.GetWarship().GetSpeed() + "  ");
        Map.toolBarLabelWieght.setText("Weight: " + warship.GetWarship().GetWeight() + "  ");
        Map.toolBarLabelColor.setText("Color: " + warship.GetWarship().GetBodyColor().getRed() + " " +
                warship.GetWarship().GetBodyColor().getGreen() + " " + warship.GetWarship().GetBodyColor().getBlue());
        bufferedImage = _abstractMap.CreateMap(750,550,new DrawingObjectWarship(warship));
    }
    //Создание обычного корабля
    public void CreateButtonAction(){
        Random rnd=new Random();
        DrawingWarship warship=new DrawingWarship(rnd.nextInt(100, 300), rnd.nextInt(1000, 2000),
                new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)), rnd.nextInt(3));
        SetData(warship);
    }
    //Создание модифицированного корабля
    public void CreateModifButtonAction(){
        Random rnd = new Random();
        DrawingWarship warship = new DrawingAircraftCarrier(rnd.nextInt(100, 300), rnd.nextInt(1000, 2000),
                new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)),
                new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)),
                rnd.nextBoolean(), rnd.nextBoolean(), rnd.nextBoolean());
        SetData(warship);
    }

    public void DirectionButtonAction(Direction side){
        if(_abstractMap != null){
            bufferedImage = _abstractMap.MoveObject(side);
        }
    }

    public void ComboBoxSelectorMapAction(String name){
        switch (name){
            case "Простая карта":
                _abstractMap = new SimpleMap();
                break;
            case "Вторая карта":
                _abstractMap = new LineMap();
                break;
        }
    }

    public void DrawMap(Graphics g){
        g.drawImage(bufferedImage,0,0,null);
    }
}
