import java.awt.*;

public class DrawingObjectWarship implements IDrawingObject {
    private DrawingWarship _warship = null;

    public DrawingObjectWarship(DrawingWarship warship)
    {
        _warship = warship;
    }

    public float Step(){
        if(_warship !=null && _warship.Warship != null)
            return _warship.Warship.Step;
        return 0;
    }

    @Override
    public void SetObject(int x, int y, int width, int height) {
        _warship.SetPosition(x, y, width, height);
    }

    @Override
    public void MoveObject(Direction direction) {
        _warship.MoveTransport(direction);
    }

    @Override
    public void DrawningObject(Graphics g) {
        _warship.DrawTransport(g);
    }

    @Override
    public float[] GetCurrentPosition() {
        if(_warship != null) return _warship.GetCurrentPosition();
        return null;
    }
}
