import javax.swing.*;
import java.awt.*;
import java.util.Objects;

public class FormMap extends JFrame{
    DrawingMap map = new DrawingMap(this);
    private JPanel mainPanel;
    private JToolBar toolBar;
    public JLabel toolBarLabelSpeed;
    public JLabel toolBarLabelWieght;
    public JLabel toolBarLabelColor;
    private JButton buttonCreate;
    private JButton buttonCreateModif;
    private JButton buttonRight;
    private JButton buttonUp;
    private JButton buttonDown;
    private JButton buttonLeft;
    private JComboBox ComboBoxSelectorMap;
    private JPanel drawPanel;

    public FormMap(){
        InitializeComponent();
    }

    private void InitializeComponent() {
        setContentPane(mainPanel);
        setTitle("Warship");
        setSize(900, 700);
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setVisible(true);

        Icon iconUp = new ImageIcon("src\\Images\\ArrowUp.jpg");
        buttonUp.setIcon(iconUp);
        Icon iconDown = new ImageIcon("src\\Images\\ArrowDown.jpg");
        buttonDown.setIcon(iconDown);
        Icon iconLeft = new ImageIcon("src\\Images\\ArrowLeft.jpg");
        buttonLeft.setIcon(iconLeft);
        Icon iconRight = new ImageIcon("src\\Images\\ArrowRight.jpg");
        buttonRight.setIcon(iconRight);

        buttonCreate.addActionListener(e -> {
            map.CreateButtonAction();
            ReDraw();
        });

        buttonCreateModif.addActionListener(e -> {
            map.CreateModifButtonAction();
            ReDraw();
        });

        buttonUp.addActionListener(e -> {
            map.DirectionButtonAction(Direction.Up);
            ReDraw();
        });

        buttonLeft.addActionListener(e -> {
            map.DirectionButtonAction(Direction.Left);
            ReDraw();
        });

        buttonRight.addActionListener(e -> {
            map.DirectionButtonAction(Direction.Right);
            ReDraw();
        });

        buttonDown.addActionListener(e -> {
            map.DirectionButtonAction(Direction.Down);
            ReDraw();
        });

        ComboBoxSelectorMap.addActionListener(e -> {
            map.ComboBoxSelectorMapAction(Objects.requireNonNull(ComboBoxSelectorMap.getSelectedItem()).toString());
            ReDraw();
        });
    }

    private void ReDraw()
    {
        Graphics2D graphics = (Graphics2D) drawPanel.getGraphics();
        graphics.clearRect(0, 0, drawPanel.getWidth(), drawPanel.getHeight());
        drawPanel.paintComponents(graphics);
        map.DrawMap(graphics);
    }
}
